function saveOptions (e) {
    console.log (e.target.value);
}

var ui = wright.design ({
    "attribs": {
        "id": "wrapper",
        "class": ["group"]
    },
    "content": [
        {
            "attribs": {
                "id": "title",
                "class": ["title", "group"]
            },
            "content": {
                "type": "span",
                "content": "Options"
            }
        },
        {
            "attribs": {
                "id": "notice",
                "class": ["notice", "group"]
            },
            "content": {
                "type": "span",
                "content": "Options are immediately saved after entering them"
            }
        },
        {
            "attribs": {
                "id": "options",
                "class": ["list", "smooth", "group"]
            },
            "content": [
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Provider"
                                    },
                                    {
                                        "type": "span",
                                        "content": "The back-end provider for streaming."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "select",
                                    "content": [
                                        {
                                            "attribs": {
                                                "value": "livestreamer"
                                            },
                                            "type": "option",
                                            "content": "livestreamer"
                                        },
                                        {
                                            "type": "option",
                                            "attribs": {
                                                "value": "yotube-dl"
                                            },
                                            "content": "yotube-dl"
                                        }
                                    ]
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Path"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Path to livestreamer executable, leave blank to detect automatically."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "path",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Optional Arguments"
                                    },
                                    {
                                        "type": "span",
                                        "content": "You can pass livestreamer options here in the form of --foo=bar,--baz=foo. Check livestreamer -h for what is available."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "optargs",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Quality Menu"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Display a quality selection window everytime livestreamer is launched."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "menu",
                                        "type": "checkbox",
                                        "checked": "checked"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                },
                {
                    "attribs": {
                        "class": ["option", "group"]
                    },
                    "content": [
                        {
                            "attribs": {
                                "class": ["info", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": [
                                    {
                                        "type": "label",
                                        "content": "Stream Quality"
                                    },
                                    {
                                        "type": "span",
                                        "content": "Change the quality of the stream, options are low, medium, best. Only applied if quality menu is disabled."
                                    }
                                ]
                            }
                        },
                        {
                            "attribs": {
                                "class": ["setting", "group"]
                            },
                            "content": {
                                "attribs": {
                                    "class": ["padding-14", "group"]
                                },
                                "content": {
                                    "type": "input",
                                    "attribs": {
                                        "id": "quality",
                                        "type": "text"
                                    },
                                    "content": ""
                                }
                            }
                        }
                    ]
                }
            ]
        }
    ]
});

if (document.body != null) {
    document.body.appendChild(ui);
}

// Emit to main.js
var options = document.querySelectorAll ("#options input, #options select");
// For each add click event
for (var i = 0; i < options.length; i++) {
    options[i].addEventListener("change", saveOptions, false);
    //options[i].addEventListener("keyup", saveOptions, false); 
    timer = 0;
    options[i].onkeyup = function (e) {
        // Wait 2 seconds, if user is done typing save.
        clearTimeout (timer);
        timer = setTimeout (function () {
            console.log (e.target.value);
        }, 2000);
    };
}
